package me.ChrisvA.MinecartExtra;

import org.bukkit.ChatColor;
import org.bukkit.entity.Player;
import org.bukkit.plugin.RegisteredServiceProvider;

import net.milkbowl.vault.economy.Economy;
import net.milkbowl.vault.economy.EconomyResponse;

public class MinecartExtraEconomy {

	private Economy economy = null;
	private MinecartExtra plugin;

	public MinecartExtraEconomy(MinecartExtra plugin){
		this.plugin = plugin;
		if(!setupEconomy()){
			this.plugin.getLogger().warning(this.plugin.getStrings().getNoEconomPlugin());
		}
	}
	
	public boolean take(Player player, double amount){
		
		if(economy.getBalance(player.getName()) < amount){
			player.sendMessage(
					ChatColor.RED + this.plugin.getStrings().getNotEnoughMoney(new Double(amount).toString())
					);
			return false;
		}
		
		EconomyResponse ecoRes = economy.withdrawPlayer(player.getName(), amount);
		
		if(!ecoRes.transactionSuccess()){
			player.sendMessage(
					ChatColor.RED + this.plugin.getStrings().getErrorTakeMoney()
					);
			return false;
		}
		
		return true;
	}
	
	private Boolean setupEconomy()
    {
        RegisteredServiceProvider<Economy> economyProvider = 
        	this.plugin.getServer().getServicesManager().getRegistration(net.milkbowl.vault.economy.Economy.class);
        if (economyProvider != null) {
            economy = economyProvider.getProvider();
        }

        return (economy != null);
    }
	
}
